diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index 5bb5f5da1..c1a723abd 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -12,14 +12,11 @@ import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.option.enums.*;
-import net.minecraft.client.render.font.Font;
 import net.minecraft.client.render.font.Fonts;
 import net.minecraft.client.render.tileentity.TileEntityRendererSign;
 import net.minecraft.client.world.chunk.provider.SelectedProvider;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.enums.ChatVisibility;
-import net.minecraft.core.enums.Difficulty;
-import net.minecraft.core.enums.PlacementMode;
+import net.minecraft.core.enums.*;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
@@ -38,52 +35,7 @@ import java.util.Collection;
 import java.util.List;
 import java.util.Map;
 
-import static org.lwjgl.input.Keyboard.KEY_1;
-import static org.lwjgl.input.Keyboard.KEY_2;
-import static org.lwjgl.input.Keyboard.KEY_3;
-import static org.lwjgl.input.Keyboard.KEY_4;
-import static org.lwjgl.input.Keyboard.KEY_5;
-import static org.lwjgl.input.Keyboard.KEY_6;
-import static org.lwjgl.input.Keyboard.KEY_7;
-import static org.lwjgl.input.Keyboard.KEY_8;
-import static org.lwjgl.input.Keyboard.KEY_9;
-import static org.lwjgl.input.Keyboard.KEY_A;
-import static org.lwjgl.input.Keyboard.KEY_B;
-import static org.lwjgl.input.Keyboard.KEY_C;
-import static org.lwjgl.input.Keyboard.KEY_COMMA;
-import static org.lwjgl.input.Keyboard.KEY_D;
-import static org.lwjgl.input.Keyboard.KEY_DOWN;
-import static org.lwjgl.input.Keyboard.KEY_E;
-import static org.lwjgl.input.Keyboard.KEY_END;
-import static org.lwjgl.input.Keyboard.KEY_F;
-import static org.lwjgl.input.Keyboard.KEY_F1;
-import static org.lwjgl.input.Keyboard.KEY_F11;
-import static org.lwjgl.input.Keyboard.KEY_F12;
-import static org.lwjgl.input.Keyboard.KEY_F2;
-import static org.lwjgl.input.Keyboard.KEY_F3;
-import static org.lwjgl.input.Keyboard.KEY_F4;
-import static org.lwjgl.input.Keyboard.KEY_F5;
-import static org.lwjgl.input.Keyboard.KEY_F8;
-import static org.lwjgl.input.Keyboard.KEY_G;
-import static org.lwjgl.input.Keyboard.KEY_GRAVE;
-import static org.lwjgl.input.Keyboard.KEY_H;
-import static org.lwjgl.input.Keyboard.KEY_L;
-import static org.lwjgl.input.Keyboard.KEY_LCONTROL;
-import static org.lwjgl.input.Keyboard.KEY_LSHIFT;
-import static org.lwjgl.input.Keyboard.KEY_N;
-import static org.lwjgl.input.Keyboard.KEY_P;
-import static org.lwjgl.input.Keyboard.KEY_PERIOD;
-import static org.lwjgl.input.Keyboard.KEY_Q;
-import static org.lwjgl.input.Keyboard.KEY_R;
-import static org.lwjgl.input.Keyboard.KEY_S;
-import static org.lwjgl.input.Keyboard.KEY_SLASH;
-import static org.lwjgl.input.Keyboard.KEY_SPACE;
-import static org.lwjgl.input.Keyboard.KEY_T;
-import static org.lwjgl.input.Keyboard.KEY_TAB;
-import static org.lwjgl.input.Keyboard.KEY_U;
-import static org.lwjgl.input.Keyboard.KEY_UP;
-import static org.lwjgl.input.Keyboard.KEY_W;
-import static org.lwjgl.input.Keyboard.KEY_Z;
+import static org.lwjgl.input.Keyboard.*;
 
 public final class GameSettings {
     private static final @NotNull Logger LOGGER = LogUtils.getLogger();
@@ -145,11 +97,6 @@ public final class GameSettings {
                 return (int) (option.value * 200F) + "%";
             }
         }));
-    public static final @NotNull OptionFloat SCREEN_PADDING = register(new OptionFloat("screenPadding", 0.0f)
-        .withDisplayStringProvider((mc, i18n, option) -> {
-            int percent = (int) (option.value * 100);
-            return percent + "%";
-        }));
     public static final @NotNull OptionFloat GAMMA = register(new OptionFloat("gamma", 0.5f)
         .withDisplayStringProvider((mc, i18n, option) -> {
             int percent = (int) (option.value * 200);
@@ -257,9 +204,7 @@ public final class GameSettings {
             }
         }));
     public static final @NotNull OptionBoolean ARMOR_DURABILITY_OVERLAY = register(new OptionBoolean("armorDurabilityOverlay", false));
-    public static final @NotNull OptionBoolean ARMOR_BAR_OVERLAY = register(new OptionBoolean("armorBarOverlay", false));
     public static final @NotNull OptionBoolean ARMOR_PROTECTION_OVERLAY = register(new OptionBoolean("armorProtectionOverlay", true));
-    public static final @NotNull OptionBoolean HELD_ITEM_COUNT_OVERLAY = register(new OptionBoolean("heldItemCountOverlay", false));
     public static final @NotNull OptionBoolean PAUSE_ON_LOST_FOCUS = register(new OptionBoolean("pauseOnLostFocus", true));
     public static final @NotNull OptionBoolean SHOW_DEBUG_SCREEN = register(new OptionBoolean("showDebugScreen", false));
     public static final @NotNull OptionBoolean SHOW_FRAME_TIMES = register(new OptionBoolean("showFrameTimes", false));
@@ -347,7 +292,6 @@ public final class GameSettings {
             mc.renderGlobal.allChanged();
         }));
     public static final @NotNull OptionInteger PLAYER_LIST_POSITION = register(new OptionInteger("playerListPosition", 2));
-    public static final @NotNull OptionBoolean HELD_ITEM_TOOLTIPS = register(new OptionBoolean("heldItemTooltips", true));
     public static final @NotNull OptionFloat COLOR_CORRECTION = register(new OptionFloat("colorCorrection", 0.5f));
     public static final @NotNull OptionBoolean SNEAK_TOGGLE = register(new OptionBoolean("sneakToggle", false));
     public static final @NotNull OptionFloat AUTOSAVE_TIMER = register(new OptionFloat("autosaveTimer", 0.04166666666F)
@@ -392,14 +336,14 @@ public final class GameSettings {
     public static final @NotNull OptionBoolean ALLOW_SOUND_OVERRIDES = register(new OptionBoolean("allowSoundOverrides", false));
     public static final @NotNull OptionBoolean LOAD_ALL_SOUNDS = register(new OptionBoolean("loadAllSounds", false));
 
-    public static final @NotNull OptionBoolean OVERLAY_SHOW_COORDS = register(new OptionBoolean("overlayShowCoords", true));
-    public static final @NotNull OptionBoolean OVERLAY_SHOW_DIRECTION = register(new OptionBoolean("overlayShowDirection", true));
-    public static final @NotNull OptionBoolean OVERLAY_SHOW_TIME = register(new OptionBoolean("overlayShowTime", true));
-    public static final @NotNull OptionBoolean OVERLAY_SHOW_SEASON = register(new OptionBoolean("overlayShowSeason", true));
-    public static final @NotNull OptionBoolean OVERLAY_SHOW_WEATHER = register(new OptionBoolean("overlayShowWeather", true));
-    public static final @NotNull OptionBoolean OVERLAY_SHOW_BIOME = register(new OptionBoolean("overlayShowBiome", true));
+    public static final @NotNull OptionBoolean COORDS_IN_OVERLAY = register(new OptionBoolean("coordsInOverlay", true));
+    public static final @NotNull OptionBoolean DIRECTION_IN_OVERLAY = register(new OptionBoolean("directionInOverlay", true));
+    public static final @NotNull OptionBoolean TIME_IN_OVERLAY = register(new OptionBoolean("timeInOverlay", true));
+    public static final @NotNull OptionBoolean SEASON_IN_OVERLAY = register(new OptionBoolean("seasonInOverlay", true));
+    public static final @NotNull OptionBoolean WEATHER_IN_OVERLAY = register(new OptionBoolean("weatherInOverlay", true));
+    public static final @NotNull OptionBoolean BIOME_IN_OVERLAY = register(new OptionBoolean("biomeInOverlay", true));
 
-    public static final @NotNull OptionBoolean @NotNull [] OVERLAY_ELEMENTS = new OptionBoolean[]{OVERLAY_SHOW_COORDS, OVERLAY_SHOW_DIRECTION, OVERLAY_SHOW_TIME, OVERLAY_SHOW_SEASON, OVERLAY_SHOW_WEATHER, OVERLAY_SHOW_BIOME};
+    public static final @NotNull OptionBoolean @NotNull [] OVERLAY_ELEMENTS = new OptionBoolean[]{COORDS_IN_OVERLAY, DIRECTION_IN_OVERLAY, TIME_IN_OVERLAY, SEASON_IN_OVERLAY, WEATHER_IN_OVERLAY, BIOME_IN_OVERLAY};
 
     public static final @NotNull OptionString LAST_SERVER = register(new OptionString("lastServer", ""));
     public static final @NotNull OptionString SKIN = register(new OptionString("skin", "Default"));
@@ -521,6 +465,69 @@ public final class GameSettings {
             }
         }));
 
+    //HudComponent Options (if already existent and, like keybinds, they just point to their respective category/existent option)
+
+    public static final @NotNull OptionBoolean SEEN_HUD_EDITOR_ONBOARDING = register(new OptionBoolean("seenHudEditorOnboarding", false));
+
+    public static final @NotNull OptionBoolean HIDE_HEALTH_BAR = register(new OptionBoolean("hideHealthBar", false));
+    public static final @NotNull OptionBoolean HIDE_OXYGEN_BAR = register(new OptionBoolean("hideOxygenBar", false));
+    public static final @NotNull OptionBoolean HIDE_FIRE_BAR = register(new OptionBoolean("hideFireBar", false));
+    public static final @NotNull OptionBoolean HIDE_VEHICLE_BAR = register(new OptionBoolean("hideVehicleBar", false));
+    public static final @NotNull OptionBoolean HIDE_DYNAMIC_TOOLTIP = register(new OptionBoolean("hideDynamicTooltip", false));
+    public static final @NotNull OptionBoolean HIDE_HELD_ITEM_COUNT = register(new OptionBoolean("hideHeldItemCount", true));
+
+    public static final @NotNull OptionEnum<ArmorHiddenState> HIDE_HELMET_BAR = register(
+        new OptionEnum<>("hideHelmetBar", ArmorHiddenState.class, ArmorHiddenState.NEVER)
+            .setIsSlider(true)
+    );
+    public static final @NotNull OptionEnum<ArmorHiddenState> HIDE_CHESTPLATE_BAR = register(
+        new OptionEnum<>("hideChestplateBar", ArmorHiddenState.class, ArmorHiddenState.NEVER)
+            .setIsSlider(true)
+    );
+    public static final @NotNull OptionEnum<ArmorHiddenState> HIDE_LEGGINGS_BAR = register(
+        new OptionEnum<>("hideLeggingsBar", ArmorHiddenState.class, ArmorHiddenState.NEVER)
+            .setIsSlider(true)
+    );
+    public static final @NotNull OptionEnum<ArmorHiddenState> HIDE_BOOTS_BAR = register(
+        new OptionEnum<>("hideBootsBar", ArmorHiddenState.class, ArmorHiddenState.NEVER)
+            .setIsSlider(true)
+    );
+
+    public static final @NotNull OptionBoolean VERTICAL_HOT_BAR = register(new OptionBoolean("verticalHotBar", false));
+    public static final @NotNull OptionBoolean VERTICAL_HELD_ITEM_COUNT = register(new OptionBoolean("verticalHeldItemCount", false));
+    public static final @NotNull OptionBoolean VERTICAL_HEALTH_BAR = register(new OptionBoolean("verticalHealthBar", false));
+    public static final @NotNull OptionBoolean VERTICAL_OXYGEN_BAR = register(new OptionBoolean("verticalOxygenBar", false));
+    public static final @NotNull OptionBoolean VERTICAL_VEHICLE_BAR = register(new OptionBoolean("verticalVehicleBar", false));
+    public static final @NotNull OptionBoolean VERTICAL_FIRE_BAR = register(new OptionBoolean("verticalFireBar", false));
+
+    public static final @NotNull OptionBoolean FLIP_HELD_ITEM_COUNT = register(new OptionBoolean("flipHeldItemCount", false));
+    public static final @NotNull OptionBoolean FLIP_HELMET_BAR = register(new OptionBoolean("flipHelmetBar", false));
+    public static final @NotNull OptionBoolean FLIP_CHESTPLATE_BAR = register(new OptionBoolean("flipChestplateBar", false));
+    public static final @NotNull OptionBoolean FLIP_LEGGINGS_BAR = register(new OptionBoolean("flipLeggingsBar", false));
+    public static final @NotNull OptionBoolean FLIP_BOOTS_BAR = register(new OptionBoolean("flipBootsBar", false));
+    public static final @NotNull OptionBoolean FLIP_HEALTH_BAR = register(new OptionBoolean("flipHealthBar", false));
+    public static final @NotNull OptionBoolean FLIP_OXYGEN_BAR = register(new OptionBoolean("flipOxygenBar", false));
+    public static final @NotNull OptionBoolean FLIP_VEHICLE_BAR = register(new OptionBoolean("flipVehicleBar", false));
+    public static final @NotNull OptionBoolean FLIP_FIRE_BAR = register(new OptionBoolean("flipFireBar", false));
+
+    public static final @NotNull OptionEnum<HorizontalTextAlignment> HORIZONTAL_INFO_TEXT_ALIGNMENT = register(
+        new OptionEnum<>("horizontalInfoTextAlignment", HorizontalTextAlignment.class, HorizontalTextAlignment.LEFT)
+            .setIsSlider(true)
+    );
+    public static final @NotNull OptionEnum<HorizontalTextAlignment> HORIZONTAL_LOG_TEXT_ALIGNMENT = register(
+        new OptionEnum<>("horizontalLogTextAlignment", HorizontalTextAlignment.class, HorizontalTextAlignment.LEFT)
+            .setIsSlider(true)
+    );
+    public static final @NotNull OptionEnum<VerticalTextAlignment> VERTICAL_INFO_TEXT_ALIGNMENT = register(
+        new OptionEnum<>("verticalInfoTextAlignment", VerticalTextAlignment.class, VerticalTextAlignment.TOP)
+            .setIsSlider(true)
+    );
+    public static final @NotNull OptionEnum<VerticalTextAlignment> VERTICAL_LOG_TEXT_ALIGNMENT = register(
+        new OptionEnum<>("verticalLogTextAlignment", VerticalTextAlignment.class, VerticalTextAlignment.TOP)
+            .setIsSlider(true)
+    );
+
+    //KeyBind Options
     public static final @NotNull KeyBinding KEY_ATTACK = register(new KeyBinding("key.attack").setDefault(InputDevice.mouse, 0));
     public static final @NotNull KeyBinding KEY_INTERACT = register(new KeyBinding("key.interact").setDefault(InputDevice.mouse, 1));
     public static final @NotNull KeyBinding KEY_PICK_BLOCK = register(new KeyBinding("key.pickBlock").setDefault(InputDevice.mouse, 2));
@@ -549,7 +556,7 @@ public final class GameSettings {
     public static final @NotNull KeyBinding KEY_HIDE_GUI = register(new KeyBinding("key.immersiveMode").setDefault(InputDevice.keyboard, KEY_F1));
     public static final @NotNull KeyBinding KEY_SCREENSHOT = register(new KeyBinding("key.screenshot").setDefault(InputDevice.keyboard, KEY_F2));
     public static final @NotNull KeyBinding KEY_TOGGLE_DEBUG = register(new KeyBinding("key.toggleDebug").setDefault(InputDevice.keyboard, KEY_F3));
-    public static final @NotNull KeyBinding KEY_TOGGLE_OVERLAY = register(new KeyBinding("key.toggleOverlay").setDefault(InputDevice.keyboard, KEY_F4));
+    public static final @NotNull KeyBinding KEY_TOGGLE_INFO_OVERLAY = register(new KeyBinding("key.toggleInfoOverlay").setDefault(InputDevice.keyboard, KEY_F4));
     public static final @NotNull KeyBinding KEY_SWITCH_PERSPECTIVE = register(new KeyBinding("key.switchPerspective").setDefault(InputDevice.keyboard, KEY_F5));
     public static final @NotNull KeyBinding KEY_CINEMATIC_CAMERA = register(new KeyBinding("key.cinematicCamera").setDefault(InputDevice.keyboard, KEY_F8));
     public static final @NotNull KeyBinding KEY_FULL_SCREEN = register(new KeyBinding("key.fullscreen").setDefault(InputDevice.keyboard, KEY_F11));
@@ -581,6 +588,17 @@ public final class GameSettings {
     public static final @NotNull KeyBinding KEY_OPEN_STATISTICS = register(new KeyBinding("key.openStatistics"));
     public static final @NotNull KeyBinding KEY_SHOW_CONSOLE = register(new KeyBinding("key.showConsole").setDefault(InputDevice.keyboard, KEY_GRAVE));
 
+    public static final @NotNull KeyBinding KEY_HUD_EDITOR_SELECT = register(new KeyBinding("key.hudEditorSelect").setDefault(InputDevice.mouse, 0));
+    public static final @NotNull KeyBinding KEY_HUD_EDITOR_OPEN_CONTEXT = register(new KeyBinding("key.hudEditorOpenContext").setDefault(InputDevice.mouse, 1));
+    public static final @NotNull KeyBinding KEY_HUD_EDITOR_EXIT = register(new KeyBinding("key.hudEditorExit").setDefault(InputDevice.keyboard, KEY_ESCAPE));
+    public static final @NotNull KeyBinding KEY_HUD_EDITOR_RESET = register(new KeyBinding("key.hudEditorReset").setDefault(InputDevice.keyboard, KEY_R));
+    public static final @NotNull KeyBinding KEY_HUD_EDITOR_NUDGE_UP = register(new KeyBinding("key.hudEditorNudgeUp").setDefault(InputDevice.keyboard, KEY_UP));
+    public static final @NotNull KeyBinding KEY_HUD_EDITOR_NUDGE_DOWN = register(new KeyBinding("key.hudEditorNudgeDown").setDefault(InputDevice.keyboard, KEY_DOWN));
+    public static final @NotNull KeyBinding KEY_HUD_EDITOR_NUDGE_LEFT = register(new KeyBinding("key.hudEditorNudgeLeft").setDefault(InputDevice.keyboard, Keyboard.KEY_LEFT));
+    public static final @NotNull KeyBinding KEY_HUD_EDITOR_NUDGE_RIGHT = register(new KeyBinding("key.hudEditorNudgeRight").setDefault(InputDevice.keyboard, Keyboard.KEY_RIGHT));
+    public static final @NotNull KeyBinding KEY_HUD_EDITOR_NUDGE_FAST = register(new KeyBinding("key.hudEditorNudgeFast").setDefault(InputDevice.keyboard, KEY_LSHIFT));
+    public static final @NotNull KeyBinding KEY_HUD_EDITOR_ONBOARDING = register(new KeyBinding("key.hudEditorOnboarding").setDefault(InputDevice.keyboard, KEY_O));
+
     public static final @NotNull List<KeyBinding> DEBUG_KEYS = new ArrayList<>();
     public static final @NotNull KeyBinding KEY_RELOAD = register(new KeyBinding("key.debug.reload").setDefault(InputDevice.keyboard, KEY_R));
     public static final @NotNull KeyBinding KEY_SWITCH_GAMEMODE = register(new KeyBinding("key.debug.gamemode").setDefault(InputDevice.keyboard, KEY_N));
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
index 185e962b9..a51f2bcb6 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
@@ -29,8 +29,6 @@ public class ItemDragHandler extends Gui {
 	
 	private final IntSet cancelRelease = new IntArraySet();
 	
-	///////////////////////
-	
 	private int cancelButtonRelease = -1; 
 	
 	private int draggingButton = -1;
@@ -40,7 +38,7 @@ public class ItemDragHandler extends Gui {
 	private ItemStack renderItemStack;
 	private int renderItemStackCount;
 	
-	// For double clicking to pick up all similar items
+	// For double-clicking to pick up all similar items
 	private Slot lastClickSlot = null;
 	private long lastClickTime = 0;
 	private boolean lastClickHoldingItem = false;
diff --git a/game/core/src/main/java/net/minecraft/core/enums/ArmorHiddenState.java b/game/core/src/main/java/net/minecraft/core/enums/ArmorHiddenState.java
new file mode 100644
index 000000000..0e44b3927
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/enums/ArmorHiddenState.java
@@ -0,0 +1,7 @@
+package net.minecraft.core.enums;
+
+public enum ArmorHiddenState {
+    NEVER,
+    WHEN_NOT_WEARING,
+    ALWAYS
+}
diff --git a/game/core/src/main/java/net/minecraft/core/enums/HorizontalTextAlignment.java b/game/core/src/main/java/net/minecraft/core/enums/HorizontalTextAlignment.java
new file mode 100644
index 000000000..c2912fae3
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/enums/HorizontalTextAlignment.java
@@ -0,0 +1,13 @@
+package net.minecraft.core.enums;
+
+public enum HorizontalTextAlignment {
+    LEFT(0.0f),
+    CENTER(0.5f),
+    RIGHT(1.0f);
+
+    public final float multiplier;
+
+    HorizontalTextAlignment(float multiplier) {
+        this.multiplier = multiplier;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/enums/VerticalTextAlignment.java b/game/core/src/main/java/net/minecraft/core/enums/VerticalTextAlignment.java
new file mode 100644
index 000000000..8fe93dbd2
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/enums/VerticalTextAlignment.java
@@ -0,0 +1,13 @@
+package net.minecraft.core.enums;
+
+public enum VerticalTextAlignment {
+    TOP(0.0f),
+    CENTER(0.5f),
+    BOTTOM(1.0f);
+
+    public final float multiplier;
+
+    VerticalTextAlignment(float multiplier) {
+        this.multiplier = multiplier;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParser.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParser.java
index a89a13518..6d839045e 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParser.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParser.java
@@ -65,7 +65,7 @@ public class WorldFeatureParser {
                 throw NO_PARAMETERS.createWithContext(this.reader);
             }
             try {
-                return (WorldFeature) constructor.newInstance();
+                return (WorldFeatureInterface) constructor.newInstance();
             } catch (Exception e) {
                 throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.world_feature.invalid_world_feature"));
             }
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
index 93e6683de..a2406e4fa 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
@@ -215,7 +215,7 @@ gui.options.label.picking_keybinding=Press a key or mouse button to set it as th
 gui.options.page.general.title=General
 gui.options.page.general.button.open_worlds_folder=Open Worlds Folder
 gui.options.page.general.button.open_screenshots_folder=Open Screenshots Folder
-gui.options.page.general.button.edit_hud=Edit HUD...
+gui.options.page.general.button.edit_hud=Open HUD Editor...
 gui.options.page.general.category.gameplay=Gameplay
 gui.options.page.general.category.user_interface=User Interface
 gui.options.page.general.category.miscellaneous=Miscellaneous
@@ -245,6 +245,7 @@ gui.options.page.controls.category.controller=Controller
 gui.options.page.controls.category.interactions=Interactions
 gui.options.page.controls.category.movement=Movement
 gui.options.page.controls.category.user_interface=User Interface
+gui.options.page.controls.category.hud_editor=HUD Editor
 gui.options.page.controls.category.hotbar=Hotbar
 gui.options.page.controls.category.view=View
 gui.options.page.controls.category.miscellaneous=Miscellaneous
@@ -297,6 +298,17 @@ gui.options.difficultylock.warning.1=Are you sure you wish
 gui.options.difficultylock.warning.2=to lock this world's difficulty?
 gui.options.difficultylock.warning.3=(This cannot be undone)
 
+gui.options.hudeditor.onboarding.welcome=Welcome to the HUD Editor!
+gui.options.hudeditor.onboarding.select=Press '%1$s' to select a component
+gui.options.hudeditor.onboarding.drag=Drag while holding '%1$s' to move component
+gui.options.hudeditor.onboarding.context=Press '%1$s' while hovering over a component for contextual settings
+gui.options.hudeditor.onboarding.nudge=Press '%1$s' to nudge any selected component
+gui.options.hudeditor.onboarding.nudge_fast=Hold '%1$s' to nudge faster
+gui.options.hudeditor.onboarding.reset=Press '%1$s' to reset layout to default
+gui.options.hudeditor.onboarding.exit=Press '%1$s' to leave the HUD Editor
+gui.options.hudeditor.onboarding.reopen=Press '%1$s' to see this screen again!
+gui.options.hudeditor.onboarding.begin=Click anywhere to begin
+
 gui.sound_test.label.title=Sound Test
 gui.sound_test.label.repo=Sound Repository: %s
 gui.sound_test.label.id=ID: %s
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
index 3d7a6fa05..1e57d8946 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
@@ -120,14 +120,13 @@ options.entityRenderDistance=Entity Render Distance
 options.entityRenderDistance.default=Default
 options.armorDurabilityOverlay=Armor Durability Overlay
 options.armorBarOverlay=Armor Bar Overlay
-options.overlayShowCoords=Coordinates
-options.overlayShowDirection=Direction
-options.overlayShowTime=Time
-options.overlayShowSeason=Season
-options.overlayShowWeather=Weather
-options.overlayShowBiome=Biome
+options.coordsInOverlay=Coordinates in Overlay
+options.directionInOverlay=Direction in Overlay
+options.timeInOverlay=Time in Overlay
+options.seasonInOverlay=Season in Overlay
+options.weatherInOverlay=Weather in Overlay
+options.biomeInOverlay=Biome in Overlay
 options.rawMouseInput=Raw Mouse Input
-options.heldItemCountOverlay=Held Item Count Overlay
 options.swapCraftingButtons=Swap Crafting Buttons
 options.fullscreen=Full Screen
 options.borderlessFullscreen=Borderless Fullscreen
@@ -135,7 +134,6 @@ options.borderlessFullscreen.unavailable=Not Available
 options.enableVbos=Enable VBOs
 options.discordRichPresence=Discord Rich Presence
 options.blockOutlineWidth=Outline Visibility
-options.heldItemTooltips=Held Item Tooltips
 options.colorCorrection=Color Correction
 options.colorCorrection.low=Low
 options.colorCorrection.high=High
@@ -265,6 +263,70 @@ options.player.hurtsound.masculine=Masculine
 options.player.hurtsound.feminine=Feminine
 options.player.hurtsound.neutral=Neutral
 
+options.hideHeldItemCount=Hide
+options.hideDynamicTooltip=Hide
+options.hideHealthBar=Hide
+options.hideOxygenBar=Hide
+options.hideFireBar=Hide
+options.hideVehicleBar=Hide
+
+options.hideHelmetBar=Hide
+options.hideHelmetBar.never=Never
+options.hideHelmetBar.when_not_wearing=When Not Wearing
+options.hideHelmetBar.always=Always
+
+options.hideChestplateBar=Hide
+options.hideChestplateBar.never=Never
+options.hideChestplateBar.when_not_wearing=When Not Wearing
+options.hideChestplateBar.always=Always
+
+options.hideLeggingsBar=Hide
+options.hideLeggingsBar.never=Never
+options.hideLeggingsBar.when_not_wearing=When Not Wearing
+options.hideLeggingsBar.always=Always
+
+options.hideBootsBar=Hide
+options.hideBootsBar.never=Never
+options.hideBootsBar.when_not_wearing=When Not Wearing
+options.hideBootsBar.always=Always
+
+options.verticalHotBar=Vertical
+options.verticalHeldItemCount=Vertical
+options.verticalHealthBar=Vertical
+options.verticalOxygenBar=Vertical
+options.verticalVehicleBar=Vertical
+options.verticalFireBar=Vertical
+
+options.flipHeldItemCount=Flip
+options.flipHelmetBar=Flip
+options.flipChestplateBar=Flip
+options.flipLeggingsBar=Flip
+options.flipBootsBar=Flip
+options.flipHealthBar=Flip
+options.flipOxygenBar=Flip
+options.flipVehicleBar=Flip
+options.flipFireBar=Flip
+
+options.horizontalInfoTextAlignment=Horizontal Alignment
+options.horizontalInfoTextAlignment.left=Left
+options.horizontalInfoTextAlignment.center=Center
+options.horizontalInfoTextAlignment.right=Right
+
+options.horizontalLogTextAlignment=Horizontal Alignment
+options.horizontalLogTextAlignment.left=Left
+options.horizontalLogTextAlignment.center=Center
+options.horizontalLogTextAlignment.right=Right
+
+options.verticalInfoTextAlignment=Vertical Alignment
+options.verticalInfoTextAlignment.top=Top
+options.verticalInfoTextAlignment.center=Center
+options.verticalInfoTextAlignment.bottom=Bottom
+
+options.verticalLogTextAlignment=Vertical Alignment
+options.verticalLogTextAlignment.top=Top
+options.verticalLogTextAlignment.center=Center
+options.verticalLogTextAlignment.bottom=Bottom
+
 key.attack=Attack
 key.interact=Interact
 key.pickBlock=Pick Block
@@ -314,13 +376,25 @@ key.autoWalk=Auto Walk
 key.easyBridge=Toggle Easy Bridge
 key.sprint=Sprint (if enabled)
 key.toggleDebug=Toggle Debug
-key.toggleOverlay=Toggle Overlays
+key.toggleInfoOverlay=Toggle Info Overlay
 key.sortInventory=Sort Inventory
 key.openAchievements=Open Achievements Menu
 key.openStatistics=Open Statistics Menu
 key.showConsole=Show Console
 key.description=Show item description
 key.disabled=Disabled
+
+key.hudEditorSelect=Select HUD Component
+key.hudEditorOpenContext=Open Component Context Menu
+key.hudEditorExit=Exit HUD Editor
+key.hudEditorReset=Reset HUD to Default
+key.hudEditorNudgeUp=Nudge Up Selected Component
+key.hudEditorNudgeDown=Nudge Down Selected Component
+key.hudEditorNudgeLeft=Nudge Left Selected Component
+key.hudEditorNudgeRight=Nudge Right Selected Component
+key.hudEditorNudgeFast=Nudge Selected Component Faster
+key.hudEditorOnboarding=Show HUD Editor Onboarding Screen
+
 key.debug.textureAtlas=Show Texture Atlas
 key.debug.textureAtlasLayer=Shift Texture Atlas Layer
 key.debug.reload=Reload textures
